//package lab6.durant;

import sun.reflect.generics.reflectiveObjects.NotImplementedException;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Collection;
import java.util.Scanner;

/**
 * Created by durant on 3/26/14.
 */
public class Dictionary {
    private Collection<String> dictionary;

    public Dictionary(Collection<String> d) {
        if (d==null)
            throw new NullPointerException();
        dictionary = d;
        clear();
    }
    public void clear() {
        dictionary.clear();
    }
    public boolean contains(String s) {
        return dictionary.contains(s.toLowerCase()); // case must be consistent with load()
    }
    public long load(File file) {
        Scanner sc = null;
        try {
            sc = new Scanner(file);
        } catch (FileNotFoundException e) {
            // nothing to do
        }

        final long startTime = System.nanoTime();
        if (sc != null) {
            sc.useDelimiter("[^a-zA-Z]+");
            //int debugAdd = 0;
            while (sc.hasNext()) {
                String w = sc.next().toLowerCase(); // case must be consistent with contains()
                //if(!dictionary.contains(w)) { // this check is OPTIONAL per the spec
                dictionary.add(w);
                //++debugAdd;
                //if (debugAdd % 5000 == 0) System.out.print(Integer.toString(debugAdd) + '.');
                //}
            }
        }
        final long stopTime = System.nanoTime();
        return stopTime-startTime;
    }
}
